# coding: utf-8

"""
    Getir-Locals Integration Swagger Documentation

    This documentation is created by Getir Developers for Getir-Locals Integration.For this integration, you need to take CLIENT NAME and CLIENT SECRET keys from Getir-dev team and use these keys for authentication. You also need to use access token provided after successful login to be able to use all other endpoints  You can view information about the active order through /orders/unapproved endpoints. The status of the order is managed via verify, prepare, handover and cancel endpoints. Details on order management are as follows:  For orders to be made by the Getir courier, the flow is as follows:  Supplier confirms order --verify<br />Supplier prepares order --prepare (1-2 minutes must pass before delivery)<br />Supplier hands over the order to Getir courier --handover<br />For Getir delivery, transactions are made by the Getir courier after handover.  A valid reason will be requested from the supplier to cancel an order. Valid reasons may vary depending on the instant status of the order. For this reason, before canceling an order, you have to get instant valid order cancellation reasons from /orders/{orderId}/cancel-options endpoint.   # noqa: E501

    OpenAPI spec version: 0.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CancelOrderRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'cancel_reason_id': 'str',
        'cancel_note': 'str',
        'products': 'list[str]'
    }

    attribute_map = {
        'cancel_reason_id': 'cancelReasonId',
        'cancel_note': 'cancelNote',
        'products': 'products'
    }

    def __init__(self, cancel_reason_id=None, cancel_note=None, products=None):  # noqa: E501
        """CancelOrderRequest - a model defined in Swagger"""  # noqa: E501
        self._cancel_reason_id = None
        self._cancel_note = None
        self._products = None
        self.discriminator = None
        self.cancel_reason_id = cancel_reason_id
        if cancel_note is not None:
            self.cancel_note = cancel_note
        if products is not None:
            self.products = products

    @property
    def cancel_reason_id(self):
        """Gets the cancel_reason_id of this CancelOrderRequest.  # noqa: E501


        :return: The cancel_reason_id of this CancelOrderRequest.  # noqa: E501
        :rtype: str
        """
        return self._cancel_reason_id

    @cancel_reason_id.setter
    def cancel_reason_id(self, cancel_reason_id):
        """Sets the cancel_reason_id of this CancelOrderRequest.


        :param cancel_reason_id: The cancel_reason_id of this CancelOrderRequest.  # noqa: E501
        :type: str
        """
        if cancel_reason_id is None:
            raise ValueError("Invalid value for `cancel_reason_id`, must not be `None`")  # noqa: E501

        self._cancel_reason_id = cancel_reason_id

    @property
    def cancel_note(self):
        """Gets the cancel_note of this CancelOrderRequest.  # noqa: E501


        :return: The cancel_note of this CancelOrderRequest.  # noqa: E501
        :rtype: str
        """
        return self._cancel_note

    @cancel_note.setter
    def cancel_note(self, cancel_note):
        """Sets the cancel_note of this CancelOrderRequest.


        :param cancel_note: The cancel_note of this CancelOrderRequest.  # noqa: E501
        :type: str
        """

        self._cancel_note = cancel_note

    @property
    def products(self):
        """Gets the products of this CancelOrderRequest.  # noqa: E501


        :return: The products of this CancelOrderRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._products

    @products.setter
    def products(self, products):
        """Sets the products of this CancelOrderRequest.


        :param products: The products of this CancelOrderRequest.  # noqa: E501
        :type: list[str]
        """

        self._products = products

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CancelOrderRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CancelOrderRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
